import socket
from Classes.Game.Player import Player
from Classes.System.GameManager import GameManager

from Classes.System.World import World


class TCPEventHandler:
    __tcpSocket:socket

    def __init__(self, socket:socket):
        self.__tcpSocket = socket

    # handles passing of event data to the right functions
    def handleTCPEvents(self, event, gameManager:GameManager, address):
        gameManager.getLogger().info(f"incommingevent {event}")
        if event["event"] == "PlaceCard":
            gameManager.getLogger().info(f"player {event['user']} attempted to place card {event['card']}")
            for playerKey in gameManager.getPlayers().keys():
                player = gameManager.getPlayers()[playerKey]
                if int(event["user"]) != player["player"].getID():
                    payload = {
                        "event":"cardPlaced",
                        "card": {
                            "card":event["card"],
                            "owner": event["user"],
                            "x": event["x"],
                            "y": event["y"]
                        }
                    }
                    player["socket"].send(payload)
            pass
        elif event["event"] == "MoveCard":
            pass
        elif event["event"] == "RemoveCard":
            pass
        elif event["event"] == "AttackCard":
            pass
        elif event["event"] == "AttackPlayer":
            pass
        elif event["event"] == "ActivateEffectCard":
            pass
        elif event["event"] == "ActivateMonsterCard":
            pass
        pass